# TACO Toolkit

The TACO Toolkit is a set of tools that helps simplify Tableau web data connector development. It contains a command-line interface (CLI) to create and publish Tableau web data connectors and an SDK that enables you to develop your connectors efficiently.

## Prerequisites

- [Node version 16 and npm version 7 and above](https://nodejs.org/en/download/)
- [Python 3.7 or higher](https://www.python.org/downloads/)
- [JDK 11 or higher](https://www.oracle.com/java/technologies/downloads/)

## Installation

1. Open your terminal and type the following command to install the TACO Toolkit:

   ```
   npm install -g @tableau/taco-toolkit
   ```

   This installs the toolkit globally. The TACO Toolkit includes:

   - TACO CLI
   - WDC boilerplate connector
   - WDC 3.0 SDK
   - Various utilities for creating, building, and packaging your connectors

2. Verify the installation by typing the following:

   ```
   taco
   ```

## License

https://help.tableau.com/current/api/webdataconnector/en-us/docs/wdc_license.html

The TACO Toolkit End User License Agreement (EULA) is also available in the installed `@tableau/taco-toolkit` package. For example, on macOS, the file is located at `/usr/local/lib/node_modules/@tableau/taco-toolkit/LICENSE.md`.
