#!/usr/bin/env node

'use strict'

const nodeVersion = process.versions.node
const semver = nodeVersion.split('.')
const major = parseInt(semver[0])

if (major < 16) {
  console.error(
    `You are running Node ${nodeVersion}. taco-scripts requires Node 16 or higher. Please update your Node version.`
  )
  process.exit(1)
}

const fs = require('fs')
if (!fs.existsSync('connector.json')) {
  console.error('taco-scripts can only be running under /connector directory.')
  process.exit(1)
}

const { run } = require('../dist/cli/taco-scripts/main')

run(process.argv)
