#!/usr/bin/env node

'use strict'

const nodeVersion = process.versions.node
const semver = nodeVersion.split('.')
const major = parseInt(semver[0])

if (major < 16) {
  console.error(
    `You are running Node ${nodeVersion}. TACO CLI requires Node 16 or higher. Please update your Node version.`
  )
  process.exit(1)
}

const { run } = require('../dist/cli/cli')
run(process.argv)
