import React from 'react'
import useConnector from './useConnector'

const ConnectorView = () => {
  const { isSubmitting, errorMessage, isInitializing, handleSubmit } = useConnector()

  const onClick = () => {
    handleSubmit([
      {
        fetcher: 'DataFetcher',
        parser: 'CsvDataParser',
        data: {
          fileType: 'csv',
        },
      },
      {
        fetcher: 'DataFetcher',
        parser: 'ExcelDataParser',
        data: {
          fileType: 'excel',
        },
      },
    ])
  }

  if (isInitializing) {
    return <div className="p-3 text-muted text-center">Initializing...</div>
  }

  return (
    <div className="box">
      <button className="btn btn-success px-5" onClick={onClick} disabled={isSubmitting}>
        Get Data
      </button>

      {errorMessage && <div className="alert alert-danger">{errorMessage}</div>}
    </div>
  )
}

export default ConnectorView
