import Connector from '@tableau/taco-toolkit'

let connectorInitialized = false
let pageLoaded = false

const connector = new Connector(() => {
  connectorInitialized = true
  submitWhenReady()
})

function submit() {
  connector.handlerInputs = [
    {
      fetcher: 'MyFetcher',
      parser: 'MyParser',
      data: {
        url: 'https://earthquake.usgs.gov/earthquakes/feed/v1.0/summary/4.5_week.geojson',
      },
    },
  ]
  connector.submit()
}

function isReadyToSubmit() {
  return connectorInitialized && pageLoaded
}

function handleSubmit() {
  const elem = document.getElementById('submitButton')
  elem.toggleAttribute('disabled')
  elem.innerText = 'Processing...'

  submit()
}

function submitWhenReady() {
  if (isReadyToSubmit()) {
    const elem = document.getElementById('submitButton')
    elem.innerText = 'Get Earthquake Data!'
    elem.removeAttribute('disabled')
    elem.addEventListener('click', handleSubmit, { once: true })
    // Remove the line below to disable the auto submission
    elem.click()
  }
}

window.addEventListener('load', function () {
  pageLoaded = true
  submitWhenReady()
})
