import { FatalError } from '../utils/logging';
import { ConnectorJson } from '../../../shared/types/connector-json';
import { Result } from '../utils/command';
interface TemplateAndDest {
    templatePath: string;
    destFilePath: string;
}
/**
 * Create taco xml files according to the information in the connector.json.
 * It does not check file existence. It overwrites if any file exists.
 */
export declare function createFiles(connectorJson: ConnectorJson, templateAndDests: TemplateAndDest[]): Promise<Result<void, FatalError>>;
export declare function writeTacoFile(templatePath: string, destFilePath: string, variableValues: Record<string, string>): Promise<void>;
export declare function getTemplateAndDestPath(tacoRootPath: string, connectorJson: ConnectorJson): TemplateAndDest[];
export declare function getTemplateVarValues(connectorJson: ConnectorJson): Record<string, string>;
export declare function getPackedTacoFilename(connectorJson: ConnectorJson, nameOnly: boolean, tacoName: string | undefined): string;
export {};
