export declare const sourceTypes: readonly ["app", "handlers"];
export type SourceType = typeof sourceTypes[number];
export declare function findTacoRootPath(): string;
/**
 * Exit with code 1 from program if the given path is not a connector root path.
 */
export declare function exitIfNotTacoRoot(rootPath: string): void;
export declare function outputLocationErrorAndExit(rootPath: string): never;
export declare function isTacoRootPath(path: string): boolean;
export declare function getConnectorFolderPath(tacoRootPath: string): string;
export declare function getConnectorJsonPath(tacoRootPath: string): string;
export declare function getConnectorAppPath(tacoRootPath: string): string;
export declare function getConnectorHandlersPath(tacoRootPath: string): string;
/**
 * Check if a taco project is using the old npm link setup.
 * Remove this when all existing projects define taco-toolkit as npm dependency.
 */
export declare function isOldDependencySetup(tacoRootPath: string): boolean;
export declare function isValidTacoFile(tacoFilePath: string): boolean;
