export type SupportedPlatform = 'win32' | 'darwin';
export declare enum ProductName {
    Prep = "Prep",
    Desktop = "Desktop"
}
export declare const PRODUCT_EXE_NAMES: Readonly<Record<ProductName, string>>;
export declare function getTableauExecutablePath(platform: SupportedPlatform, productName: ProductName, tableauVersion: string): string;
export declare function isSupportedPlatform(platform: string): platform is SupportedPlatform;
/**
 * Get the tableau major version which only includes the first 2 numbers in the version
 */
export declare function getTableauMajorVersion(version: string): string;
