import { Command } from 'commander';
/**
 * A function to add command options and arguments
 */
export type CommandSetup = (program: Command) => Command;
export type CommandHandler = (program: Command) => void;
interface CommandConfig {
    handler: CommandHandler;
    loggingOptions?: LoggingOptions;
    setup?: CommandSetup;
}
interface LoggingOptions {
    verbose: true;
    logLevel?: true;
}
export declare function createScriptCommand(name: string, description: string, config: CommandConfig): Command;
export declare function addLoggingOptions(program: Command, loggingOptions: LoggingOptions | undefined): Command;
export {};
