import express from 'express';
import { ColumnHeader } from '../types/column-header';
import { DataRow } from '../../shared/types/data-row';
import { Table } from './table-manager';
export declare function getOffsetParam(req: express.Request): number;
export declare function getLimitParam(req: express.Request): number;
export declare function getCountParam(req: express.Request): number;
export declare function getResetParam(req: express.Request): boolean;
export declare function getOptionalStringQueryParam(req: express.Request, paramName: string): string | undefined;
export declare function getTableDataRows(table: Table, params: {
    count: number;
    preview: boolean;
}): Promise<DataRow[]>;
export declare function getRowsForResponse(datarows: DataRow[], columns: ColumnHeader[]): (string | number | boolean | object | null)[][];
