import { NetworkAdapterOptions } from '../modules/network-adapter';
import { AppLogOption } from '../types/app-log-option';
import { ExtractorOptions, ExtractorPortConfig } from '../types/extractor-options';
export interface ExtractorAppConfig {
    readonly epsInstanceId: string;
    readonly callerId: string;
    readonly extractorId: string;
    readonly epsTempDirPath: string;
    readonly extractorOptions: ExtractorOptions;
    readonly portConfig: ExtractorPortConfig;
    readonly logOption: AppLogOption;
    readonly networkAdapterOptions: NetworkAdapterOptions;
}
/**
 * Compose Extractor app config from process args and environment variables.
 *
 * Wrap the logic into a function to trigger the value parsing on demand.
 */
export declare function getExtractorAppConfig(): ExtractorAppConfig;
