import { ColumnHeader } from '../../../types/column-header';
import { DataRow } from '../../../../shared/types/data-row';
export declare abstract class TacoFileParser {
    /**
     * Set columns metadata info to the parser. When columnHeaders are set,
     * getColumnHeaders should respect the given info.
     */
    abstract setColumnHeaders(columnHeaders: ColumnHeader[]): void;
    /**
     * Get ColumnHeaders for the table in the file.
     *
     * If columns metadata is set by setColumnHeaders, this method impl should
     * respect the columns with the given columnHeaders.
     */
    abstract getColumnHeaders(): Promise<ColumnHeader[]>;
    abstract getRowCount(): Promise<number>;
    abstract getDataRows(limit: number, offset: number): Promise<{
        data: DataRow[];
        hasMoreRows: boolean;
    }>;
}
