import { HandlerInput, IngestorHandlerInput } from '../../shared/types/handler-input';
import { TableMetadata } from '../types/table-metadata';
import { NetworkAdapter } from '../modules/network-adapter';
import { TempDataManager } from '../modules/temp-data-manager';
import { ExtractorOptions } from '../types/extractor-options';
import { Table } from './table-manager';
import { DeferredFileTable } from './tables/deferred-file-table';
import { DeferredMemoryTable } from './tables/deferred-memory-table';
import { IngestorTable } from './tables/ingestor-table';
export declare class PipelineRunner {
    private readonly extractorId;
    private readonly extractorOptions;
    private readonly tempDataManager;
    private readonly networkAdapter;
    private namedPipelineStatus;
    constructor(extractorId: string, extractorOptions: ExtractorOptions, tempDataManager: TempDataManager, networkAdapter: NetworkAdapter);
    runInitialPipeline(handlerInput: HandlerInput<unknown>): Promise<Table[]>;
    private runPipeline;
    runDeferredPipeline(table: DeferredMemoryTable | DeferredFileTable): Promise<void>;
    runIngestorMetadaPipeline(tableName: string, handlerInput: IngestorHandlerInput<unknown>): Promise<TableMetadata | undefined>;
    runIngestorDataIngestPipeline(table: IngestorTable, metadata: TableMetadata | undefined, handlerInput: IngestorHandlerInput<unknown>): Promise<void>;
}
