export interface HandlerMetadata {
    path: string;
    className: string;
}
interface HandlerResolutionConfig {
    /** handler file name without extension */
    handlerName: string | undefined;
    /** flag to indicate if the handler is required */
    required: boolean;
    /** the type of handler to resolve -- for logging, etc. */
    handlerType: string;
    /** connector's unpack handlers folder with full path */
    handlersDirPath: string;
}
/**
 * Resolve custom handler name in handlerInput into a full file path.
 */
export declare function resolveHandlerFile(resolutionConfig: HandlerResolutionConfig): HandlerMetadata | undefined;
export {};
