import { IngestorHandlerInput } from '../../../shared/types/handler-input';
import { NetworkAdapter } from '../../modules/network-adapter';
import { TempDataManager } from '../../modules/temp-data-manager';
import { ExtractorOptions } from '../../types/extractor-options';
import { TableMetadata } from '../../types/table-metadata';
import { TacoFileParser } from '../handlers/taco-parser/base-taco-file-parser';
import { HandlerMetadata } from './handler-resolver';
import { SandboxPipeline } from './sandbox-pipeline';
interface IngestorHandlerConfig {
    ingestor: HandlerMetadata;
}
export declare class IngestorPipeline extends SandboxPipeline {
    protected readonly handlerInput: IngestorHandlerInput<unknown>;
    protected handlerConfig: IngestorHandlerConfig;
    constructor(handlerInput: IngestorHandlerInput<unknown>, extractorId: string, extractorOptions: ExtractorOptions, tempDataManager: TempDataManager, networkAdapter: NetworkAdapter);
    getTables(): Promise<string[]>;
    getMetadata(tableName: string): Promise<TableMetadata | undefined>;
    ingestData(tableName: string, metadata: TableMetadata | undefined): Promise<{
        parser: TacoFileParser;
    }>;
    protected resolveHandlers(): IngestorHandlerConfig;
}
export {};
