import { DataContainer } from '../../../shared/types/data-container';
import { BasicHandlerInput } from '../../../shared/types/handler-input';
import { NetworkAdapter } from '../../modules/network-adapter';
import { TempDataManager } from '../../modules/temp-data-manager';
import { ExtractorOptions } from '../../types/extractor-options';
import { HandlerMetadata } from './handler-resolver';
import { SandboxPipeline } from './sandbox-pipeline';
interface MemoryTableHandlerConfig {
    auth?: HandlerMetadata;
    fetcher: HandlerMetadata;
    parser: HandlerMetadata;
}
export declare class MemoryTablePipeline extends SandboxPipeline {
    private readonly handlerInput;
    handlerConfig: MemoryTableHandlerConfig;
    constructor(handlerInput: BasicHandlerInput<unknown>, extractorId: string, extractorOptions: ExtractorOptions, tempDataManager: TempDataManager, networkAdapter: NetworkAdapter);
    run(): Promise<DataContainer>;
    private runDataGatheringPhase;
    private resolveHandlers;
    private loadHandlers;
}
export {};
