import { AuthResult } from '../../../shared/types/auth-result';
import { HandlerInput } from '../../../shared/types/handler-input';
import { NetworkAdapter } from '../../modules/network-adapter';
import { TempDataManager } from '../../modules/temp-data-manager';
import SandboxVM from '../../sandbox/sandbox-vm';
import { ExtractorOptions } from '../../types/extractor-options';
import { HandlerMetadata } from './handler-resolver';
export declare abstract class SandboxPipeline {
    protected readonly extractorOptions: ExtractorOptions;
    protected readonly extractorId: string;
    protected readonly tempDataManager: TempDataManager;
    protected readonly networkAdapter: NetworkAdapter;
    protected readonly sandboxVM: SandboxVM;
    constructor(extractorOptions: ExtractorOptions, extractorId: string, tempDataManager: TempDataManager, networkAdapter: NetworkAdapter);
    protected runAuthPhase(handlerConfig: {
        auth?: HandlerMetadata;
    }, handlerInput: HandlerInput): Promise<AuthResult>;
    protected executePipelineCode(code: string, params: unknown[]): Promise<any>;
}
