import { HandlerInput } from '../../shared/types/handler-input';
import { NetworkAdapter } from '../modules/network-adapter';
import { TempDataManager } from '../modules/temp-data-manager';
import { ExtractorOptions } from '../types/extractor-options';
import { DeferredFileTable } from './tables/deferred-file-table';
import { DeferredMemoryTable } from './tables/deferred-memory-table';
import { FileTable } from './tables/file-table';
import { IngestorTable } from './tables/ingestor-table';
import { MemoryTable } from './tables/memory-table';
export type Table = MemoryTable | FileTable | DeferredMemoryTable | DeferredFileTable | IngestorTable;
export declare class TableManager {
    private tables;
    private pipelineRunner;
    constructor(extractorId: string, extractorOptions: ExtractorOptions, tempDataManager: TempDataManager, networkAdapter: NetworkAdapter);
    init(handlerInputs: Readonly<HandlerInput<unknown>[]>): Promise<void>;
    getTable(tableName: string): Table | undefined;
    hasTable(tableName: string): boolean;
    getTableNames(): string[];
}
