import { DataRow } from '../../../shared/types/data-row';
import { DataTable } from '../../../shared/types/data-table';
import { FileBasedHandlerInput } from '../../../shared/types/handler-input';
import { TableMetadata } from '../../types/table-metadata';
import { TacoFileParser } from '../handlers/taco-parser/base-taco-file-parser';
import { PipelineRunner } from '../pipeline-runner';
export declare class DeferredFileTable {
    private readonly dataTable;
    private readonly pipelineRunner;
    private deferredHandlerInput;
    private parser;
    private offset;
    private hasMoreRows;
    constructor(dataTable: DataTable, pipelineRunner: PipelineRunner);
    getTableName(): string;
    getDeferredHandlerInput(): Readonly<FileBasedHandlerInput<unknown>>;
    getMetadata(): Promise<TableMetadata>;
    getNextDataRows(count: number): Promise<DataRow[]>;
    hasNextRow(): Promise<boolean>;
    resetOffset(): void;
    getDataRows(count: number, offset: number): Promise<{
        data: DataRow[];
        hasMoreRows: boolean;
    }>;
    getRowCount(): Promise<number>;
    setParser(parser: TacoFileParser): void;
    private getParser;
}
