import { DataRow } from '../../../shared/types/data-row';
import { DataTable } from '../../../shared/types/data-table';
import { BasicHandlerInput } from '../../../shared/types/handler-input';
import { TableMetadata } from '../../types/table-metadata';
import { PipelineRunner } from '../pipeline-runner';
import { MemoryTable } from './memory-table';
export declare class DeferredMemoryTable extends MemoryTable {
    private readonly pipelineRunner;
    private deferredHandlerInput;
    private deferredPipelineComplete;
    constructor(dataTable: DataTable, pipelineRunner: PipelineRunner);
    getDeferredHandlerInput(): Readonly<BasicHandlerInput<unknown>>;
    getMetadata(): Promise<TableMetadata>;
    getNextDataRows(count: number): Promise<DataRow[]>;
    getDataRows(count: number, offset: number): Promise<{
        data: DataRow[];
        hasMoreRows: boolean;
    }>;
    getRowCount(): Promise<number>;
    hasNextRow(): Promise<boolean>;
    mergeDataTable(incomingTable: DataTable): void;
    private runDeferredPipeline;
}
