import { DataRow } from '../../../shared/types/data-row';
import { TableMetadata } from '../../types/table-metadata';
import { TacoFileParser } from '../handlers/taco-parser/base-taco-file-parser';
export declare class FileTable {
    private readonly tableName;
    private readonly parser;
    private offset;
    private hasMoreRows;
    constructor(tableName: string, parser: TacoFileParser);
    getTableName(): string;
    getMetadata(): Promise<TableMetadata>;
    getNextDataRows(count: number): Promise<DataRow[]>;
    hasNextRow(): Promise<boolean>;
    resetOffset(): void;
    getDataRows(count: number, offset: number): Promise<{
        data: DataRow[];
        hasMoreRows: boolean;
    }>;
    getRowCount(): Promise<number>;
}
