import { DataRow } from '../../../shared/types/data-row';
import { IngestorHandlerInput } from '../../../shared/types/handler-input';
import { TableMetadata } from '../../types/table-metadata';
import { TacoFileParser } from '../handlers/taco-parser/base-taco-file-parser';
import { PipelineRunner } from '../pipeline-runner';
export declare class IngestorTable {
    private readonly tableName;
    private readonly handlerInput;
    private readonly pipelineRunner;
    private parser;
    private metadata;
    private offset;
    private hasMoreRows;
    constructor(tableName: string, handlerInput: IngestorHandlerInput<unknown>, pipelineRunner: PipelineRunner);
    getTableName(): string;
    getMetadata(): Promise<TableMetadata>;
    getNextDataRows(count: number): Promise<DataRow[]>;
    hasNextRow(): Promise<boolean>;
    getDataRows(count: number, offset: number): Promise<{
        data: DataRow[];
        hasMoreRows: boolean;
    }>;
    getRowCount(): Promise<number>;
    resetOffset(): void;
    setParser(parser: TacoFileParser): void;
    private getParser;
    private getParserForMetadata;
}
