/// <reference types="node" />
import EventEmitter from 'node:events';
import { EpsApiOptions } from '../../types/eps-api-options';
export default class EpsApi {
    private readonly app;
    private readonly port;
    private readonly apiOptions;
    private readonly extractHandler;
    private readonly extractorLaunchedEvent;
    constructor(extractorLaunchedEvent: EventEmitter, options: EpsApiOptions);
    private initApiSettings;
    private initApiRoutes;
    private createCorsRules;
    private interceptRequests;
    private createRootRoute;
    private createRoutePermission;
    private createRouteLaunch;
    private createRouteAppUrl;
    /**
     * Usage:
     * * DELETE /extractor/{extractor IDs separated by comma}
     * * DELETE /extractor/
     */
    private createRouteExtractor;
    private createRouteClose;
    private createRouteExtract;
    private createRouteLog;
    /**
     * The route for EPS health check.
     */
    private createRouteStatus;
    private getSecrets;
    start(): Promise<void>;
    private getOrInitDistinctConnectorName;
}
