import { StatusCodes } from 'http-status-codes';
import { I18nConfig } from '../../../types/i18n-config';
import { StaticServerOptions } from '../../../types/static-server-options';
export interface RouteAppUrlConfig {
    staticServerOptions: StaticServerOptions;
}
export type WebAuthoringAppUrlRequest = {
    connectionId: string;
    connectorClass: string;
    pluginPath: string | undefined;
    staticServerOptions: StaticServerOptions;
    i18n: I18nConfig;
};
export type AppUrlApiResponse = {
    connectorAppUrl: string;
};
export type AppUrlResponse = {
    httpStatusCode: StatusCodes;
    response: AppUrlApiResponse;
};
export declare function getWebAuthoringAppUrl({ connectionId, connectorClass, pluginPath, staticServerOptions, i18n, }: WebAuthoringAppUrlRequest): Promise<AppUrlApiResponse>;
