import { StatusCodes } from 'http-status-codes';
import { ConnectorLaunchStatus } from '../../../../shared/enums/connector-launch-status';
type EPSHandlerErrorInfo = {
    errorCode?: string;
    connectorClass?: string;
    connectorLaunchStatus?: ConnectorLaunchStatus;
    httpStatusCode?: StatusCodes;
};
export declare const ERROR_CODE_BAD_TACO = "0x78715AB7";
export declare const ERROR_CODE_GENERAL_EXTRACTOR = "0x78715AB7";
export declare class EpsHandlerError extends Error {
    error: string;
    errorInfo: EPSHandlerErrorInfo;
    constructor(error: string, errorInfo: EPSHandlerErrorInfo);
    get httpStatusCode(): StatusCodes | undefined;
}
export declare function getOrInitializeDistinctConnectorName({ connectionId, connectorClass, tacoPath, }: {
    connectionId: string;
    connectorClass: string;
    tacoPath?: string;
}): Promise<string>;
export declare function getExtractorLaunchedConnectionId(connectionId: string): string;
export declare function validateCallerId(callerId: string | undefined, expectedCallerId: string): void;
export declare function validateInstanceId(epsInstanceId: string | undefined, expectedInstanceId: string): void;
export declare function validatePluginPath(pluginPath: unknown): void;
export {};
