import { StaticServerOptions } from '../../../types/static-server-options';
import { EpsAppOptions } from '../../../types/eps-app-options';
import { CommandOptionValues } from './command-line-parser';
import { EpsEnvConfig } from './env-config';
import { NetworkAdapterOptions } from '../../../modules/network-adapter';
export declare const ServerMode: {
    readonly prod: "prod";
    readonly dev: "dev";
};
export type ServerModeName = (typeof ServerMode)[keyof typeof ServerMode];
export declare function getStaticServerOptions(epsAppOptions: EpsAppOptions): Promise<StaticServerOptions>;
export declare function getGrpcPort(epsAppOptions: EpsAppOptions): Promise<number>;
export declare function getReservedPorts(optionValues: CommandOptionValues): number[];
interface ServiceEnablements {
    browserWatcher: boolean;
    staticServer: boolean;
    grpcServer: boolean;
}
export declare function getServiceEnablements(epsAppOptions: EpsAppOptions): ServiceEnablements;
export declare function getNetworkOptions(envConfig: EpsEnvConfig, optionValues: CommandOptionValues): NetworkAdapterOptions;
export {};
