import { NetworkAdapterOptions } from '../../../modules/network-adapter';
import { CommandOptionValues } from './command-line-parser';
export interface EpsEnvConfig {
    httpProxy: string | undefined;
    caCertPath: string | undefined;
}
export declare function getEnvConfig(): EpsEnvConfig;
/**
 * Setting config for child apps via environment variables.
 *
 * Prefix the variables with 'EPS_' to differentiate with the public ones prefixed with 'WDC_'.
 * The settings are for child apps. Don't reference them in the EPS main process.
 */
export declare function setChildAppEnvConfig(optionValues: CommandOptionValues, networkOption: NetworkAdapterOptions): void;
