export declare class TempDataManager {
    readonly epsInstanceId: string;
    readonly tempDirRootPath: string;
    constructor(epsInstanceId: string, tempDirRootPath: string);
    getTempDataFilePath(extractorId: string, filename: string): string;
    /**
     * Retrieves the directory path containing partitioned data stored as multiple files
     * associated with a specific table. e.g. parquet data
     *
     * @returns The directory path for the partitioned data of the specified table and extractor.
     * example: <tempDirRootPath>/tempData/eps-489f4343-1e73-4a22-b047-f0063969c28a/ext-b8ced5be-a728-4a71-98b4-6674cb064498/f-098f6bcd4621d373cade4e832627b4f6/
     */
    getTempDataDirPath(extractorId: string, dirName: string): string;
    createTempDataDirIfNotExists(extractorId: string): string;
    deleteExtractorTempDataDir(extractorId: string): void;
    deleteEpsTempDataDir(): void;
}
