import { HTTPMethod } from '../../../../shared/types/http';
import SandboxVM from '../../sandbox-vm';
import { SandboxPlugin } from '../sandbox-plugin';
type AllowedMethodType = Extract<HTTPMethod, 'GET' | 'POST'>;
export declare const queryStringToObject: (queryString: string) => Record<string, string>;
export declare const toCanonicalQueryString: (queryString: string) => string;
export declare class AwsSigningUtils extends SandboxPlugin {
    registerClass(sandbox: SandboxVM): void;
    static getHeadersV4(signingInput: {
        httpMethod: AllowedMethodType;
        url: string;
        awsRegion: string;
        awsService: string;
        secretKey: string;
        accessKey: string;
        payload: string;
        sessionToken: string;
    }): Promise<Record<string, string>>;
}
export {};
