import { LogLevel } from '../../shared/logger/log-level';
/**
 * Log options as the logging config inputs for applications.
 * Applications use the this options to create logger config which is used to
 * initialize logger.
 *
 * The option values are also passed with EPS app options to sibling and child
 * processes, e.g. static server, extractors. So some properties are defined
 * as undefined on purpose to make easier to set the values to env vars for
 * forked process.
 */
export type AppLogOption = GenericLogOption | ConsoleOnlyLogOption;
export interface GenericLogOption {
    logDir: string;
    logLevel: LogLevel;
    consoleLogLevel: LogLevel | undefined;
}
export interface ConsoleOnlyLogOption {
    consoleLogLevel: LogLevel;
    logDir: undefined;
    logLevel: undefined;
}
export declare function isConsoleOnlyAppLogOption(option: AppLogOption): option is ConsoleOnlyLogOption;
export declare function isGenericLogOption(option: AppLogOption): option is GenericLogOption;
