import { AggType, ColumnRole, ColumnType, DataType, GeographicRole, NumberFormat, UnitsFormat } from '../../shared/enums/column-header-property';
/**
 * The type for column metadata in a {@link DataTable}.
 */
export type ColumnHeader = {
    id: string;
    dataType: DataType;
    aggType?: AggType;
    alias?: string;
    columnRole?: ColumnRole;
    columnType?: ColumnType;
    description?: string;
    filterable?: boolean;
    foreignKey?: ColumnReference;
    geoRole?: GeographicRole;
    /** FYI: this is not in the WDC docs */
    hidden?: boolean;
    numberFormat?: NumberFormat;
    unitsFormat?: UnitsFormat;
};
/** @ignore */
export type ColumnReference = {
    tableId: string;
    columnId: string;
};
