import { CallerType } from '../../shared/enums/caller-type';
import { NetworkAdapterOptions } from '../modules/network-adapter';
import { FeatureFlags } from './feature-flags';
import { I18nConfig } from './i18n-config';
export type EpsAppOptions = {
    callerId: string;
    epsInstanceId: string;
    featureFlags: FeatureFlags;
    mainApiPort: number | undefined;
    portFilePath: string;
    connectorAppDir: string;
    staticServerPort: number | undefined;
    callerType: CallerType;
    grpcServerPort: number | undefined;
    networkOption: NetworkAdapterOptions;
    i18n: I18nConfig;
};
export declare class DefaultAppOptions implements EpsAppOptions {
    callerId: string;
    epsInstanceId: string;
    featureFlags: DefaultFeatureFlags;
    mainApiPort: number;
    portFilePath: string;
    connectorAppDir: string;
    staticServerPort: number;
    callerType: CallerType;
    grpcServerPort: number;
    networkOption: NetworkAdapterOptions;
    i18n: I18nConfig;
}
declare class DefaultFeatureFlags implements FeatureFlags {
    EPSSupportgRPC: boolean;
    EPSStaticTacoUnpack: boolean;
}
export {};
