import { SecretsType } from '../../shared/types/secrets-type';
import { ConnectorLaunchStatus } from '../../shared/enums/connector-launch-status';
import { ExtractorType } from '../../shared/enums/extractor-type';
import { ConnectionData } from '../../shared/types/connection-data';
export type ExtractApiResponse = EpsExtractResponse | ExtractAbortedResponse | ExtractCanceledResponse;
export interface EpsExtractResponse {
    status: ConnectorLaunchStatus.Extract | ConnectorLaunchStatus.Error;
    port: number;
    extractorId: string;
    extractorType: ExtractorType.eps;
    errorMessage?: string;
    connectionData?: ConnectionData;
    secrets?: SecretsType;
    connectorName?: string;
}
interface ExtractAbortedResponse {
    status: ConnectorLaunchStatus.Aborted;
}
interface ExtractCanceledResponse {
    status: ConnectorLaunchStatus.Canceled;
}
export {};
