export declare enum AuthType {
    oauth2 = "oauth2",
    custom = "custom",
    none = "none"
}
export type AuthTypeName = `${AuthType}`;
export interface OAuthType {
    type: AuthType.oauth2;
    oauth: {
        clientIdDesktop: string;
        clientSecretDesktop: string;
        redirectUrisDesktop: string[];
        authUri: string;
        tokenUri: string;
        userInfoUri: string;
        scopes: string[];
        capabilities: Record<string, boolean>;
        accessTokenResponseMaps: Record<string, string>;
        oauthConfigId?: string;
        configLabel?: string;
        instanceUrlSuffix?: string;
        instanceUrlValidationRegex?: string;
        defaultInstanceUrl?: string;
        refreshTokenResponseMaps?: Record<string, string>;
    };
}
interface CustomAuthType {
    type: AuthType.custom;
}
interface NoneAuthType {
    type: 'none';
}
export type AuthenticationType = OAuthType | NoneAuthType | CustomAuthType;
export {};
