/**
 * The data type for a table column.
 */
export declare enum DataType {
    Bool = "bool",
    Date = "date",
    Datetime = "datetime",
    Float = "float",
    Int = "int",
    String = "string",
    Geometry = "geometry",
    Unknown = "unknown"
}
/**
 * The aggregation type for a table column. It can be assigned as metadata
 * for columns of the int and float dataType.
 * */
export declare enum AggType {
    Avg = "avg",
    Count = "count",
    CountDist = "count_dist",
    Median = "median",
    Sum = "sum"
}
/**
 * The role for a table column.
 */
export declare enum ColumnRole {
    Dimension = "dimension",
    Measure = "measure"
}
/**
 * The type for a table column.
 */
export declare enum ColumnType {
    Continuous = "continuous",
    Discrete = "discrete"
}
/**
 * The geographic role for a table column.
 */
export declare enum GeographicRole {
    AreaCode = "area_code",
    /** core-based statistical area / metropolitan statistical area */
    CbsaMsa = "cbsa_msa",
    City = "city",
    CongressionalDistrict = "congressional_district",
    CountryRegion = "country_region",
    County = "county",
    StateProvince = "state_province",
    ZipCodePostcode = "zip_code_postcode",
    Latitude = "latitude",
    Longitude = "longitude"
}
/**
 * The number format for a table column. It can be assigned as metadata
 * for columns of the int and float dataType.
 * */
export declare enum NumberFormat {
    Number = "number",
    Currency = "currency",
    Scientific = "scientific",
    Percentage = "percentage"
}
/**
 * The unit format for a table column. It can be assigned as metadata
 * for columns of the int and float dataType.
 * */
export declare enum UnitsFormat {
    Thousands = "thousands",
    Millions = "millions",
    BillionsEnglish = "billions_english",
    BillionsStandard = "billions_standard"
}
