/**
 * Connector launch/extract status derived from ExtractorMessage status which is
 * the original message sent from extractor app.
 *
 * This status is used in the EPS /extract api responses.
 */
export declare enum ConnectorLaunchStatus {
    /**
     * Extractor process gets started, extractor API is ready, and the initial
     * data extraction completes.
     */
    Extract = "extract",
    /**
     * Extractor process gets started, extractor API is ready, but the initial
     * data extraction fails.
     */
    Error = "error",
    /**
     * App user explicitly cancels the connection, e.g. close the connector UI.
     */
    Canceled = "canceled",
    /**
     * Extractor process has started, but the process crashes during data extraction.
     * Normally, the error is logged on the extractor side.
     */
    Aborted = "aborted",
    /**
     * Seems it was designated for taco/connector related errors, it's currently
     * misused for all unknowns...
     */
    BadTaco = "badTaco"
}
