/**
 * Represents the name of a built-in Taco file parser.
 *
 * @typedef {string} TacoFileParserName
 *
 * @example
 * ```ts
 * const parserName: TacoFileParserName = 'taco:csv-file-parser';
 * ```
 */
export type TacoFileParserName = 'taco:excel-file-parser' | 'taco:csv-file-parser' | 'taco:parquet-file-parser' | 'taco:data-file-parser';
export declare const TacoFileParser: Record<string, TacoFileParserName>;
export declare function isTacoFileParserName(value: string): value is TacoFileParserName;
