import { LogLevel } from '../log-level';
import { BatchableWriter, WriterConfig } from './writer';
interface HttpWriterConfig extends WriterConfig {
    /** The http logging endpoint url*/
    endpoint: string;
    /** The headers to use in the http request*/
    headers?: Record<string, string>;
    /** Flag to enable batching*/
    batch?: true;
    /** The time in ms to wait before sending the http request*/
    batchInterval?: number;
}
export declare const DEFAULT_BATCH_INTERVAL = 3000;
export declare class HttpWriter extends BatchableWriter {
    private batch;
    private endpoint;
    private headers;
    private logEntryQueue;
    private batchTimeoutId;
    private batchInterval;
    constructor(config: HttpWriterConfig);
    log(message: string, level: LogLevel): void;
    flush(): void;
    private doBatch;
    private emitLogs;
}
export {};
