import { LogLevel } from '../log-level';
import { LogOptions } from '../log-options';
export interface WriterConfig {
    level?: LogLevel;
}
export declare abstract class Writer {
    private severity;
    private loggerSeverity;
    constructor(config: WriterConfig);
    setLoggerLevel(level: LogLevel): void;
    getMaxSeverity(): number | undefined;
    isLoggable(level: LogLevel): boolean;
    abstract log(message: string, level: LogLevel, options?: LogOptions): void;
}
export declare abstract class BatchableWriter extends Writer {
    abstract flush(): void;
}
