import { HTTPMethod } from './http';
export type ForwardedRequest = ForwardedGetRequest | ForwardedPostRequest;
interface ForwardedGetRequest extends BaseForwardedRequest {
    method: Extract<HTTPMethod, 'GET'>;
}
interface ForwardedPostRequest extends BaseForwardedRequest {
    method: Extract<HTTPMethod, 'POST'>;
    body?: object;
}
interface BaseForwardedRequest {
    url: string;
    headers?: Record<string, string>;
}
export interface ForwardedRequestOptions {
    method: Extract<HTTPMethod, 'GET' | 'POST'>;
    url: string;
    headers?: BaseForwardedRequest['headers'];
    body?: ForwardedPostRequest['body'];
}
export {};
