/**
 * Represents a single row of data in a {@link DataTable}, where each property corresponds to a column.
 *
 * @example
 * ```ts
 * const dataRow: DataRow = {
 *   column1: 'value1',
 *   column2: 42,
 *   column3: true,
 *   // other columns...
 * };
 * ```
 */
export type DataRow = Record<string, string | number | boolean | object | null>;
