/**
 * Represents a collection of secrets with string keys and values.
 *
 * @typedef {Object} SecretsType
 * @property {string | string[] | undefined} key - The value associated with the corresponding key.
 *
 * @example
 * ```ts
 * const secrets: SecretsType = {
 *   accessToken: 'access_Token',
 *   refreshToken: 'refresh_Token',
 *   // other secrets...
 * }
 *
 * // Usage to retrieve a secret value
 * const { accessToken, refreshToken } = secrets
 * ```
 */
export type SecretsType = Record<string, string | string[] | undefined>;
